#ifndef CRYPTUTIL_H
#define CRYPTUTIL_H

#ifdef __cplusplus
extern "C" {
#endif


struct crypthelper_struct;
typedef struct crypthelper_struct crypthelper_t;


crypthelper_t* crypthelper_alloc();
void crypthelper_free(crypthelper_t *helper);

const char* crypthelper_getptr(const crypthelper_t *helper);
long crypthelper_getlen(const crypthelper_t *helper);

int cryptutil_encrypt(crypthelper_t *helper, const char *in, int in_len,
            const char *pw, int pw_len);
int cryptutil_decrypt(crypthelper_t *helper, const char *in, int in_len,
            const char *pw, int pw_len);

void cleanup_openssl_library();

#ifdef __cplusplus
}
#endif

#endif
