//
//  Cryptograph.m
//  SealedPad
//
//  Created by 柴田 正明 on 10/09/11.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#include "cryptutil.h"

#import "Cryptograph.h"


@implementation Cryptograph

- (id)init
{
    self = [super init];
    if (self) {
        helper_ = crypthelper_alloc();
    }
    return self;
}

- (void)dealloc
{
    crypthelper_free(helper_);
    [super dealloc];
}

- (NSData *)dataEncryptedFromString:(NSString *)string withPassword:(NSString *)password
{
    NSData *stringData = [string dataUsingEncoding:NSUTF8StringEncoding];
    const char *stringPointer = [stringData bytes];
    int stringLength = [stringData length];
    
    NSData *passwordData = [password dataUsingEncoding:NSUTF8StringEncoding];
    const char *passwordPointer = [passwordData bytes];
    int passwordLength = [passwordData length];
    
    int result = cryptutil_encrypt(helper_, stringPointer, stringLength,
                                   passwordPointer, passwordLength);
    NSData *dataResult = nil;
    if (result == 0) {
        const char *resultPointer = crypthelper_getptr(helper_);
        int resultLength = crypthelper_getlen(helper_);
        dataResult = [[[NSData alloc] initWithBytes:resultPointer length:resultLength] autorelease];
    }
    return dataResult;
}

- (NSString *)stringDecryptedFromData:(NSData *)data withPassword:(NSString *)password
{
    const char *dataPointer = [data bytes];
    int dataLength = [data length];
    
    NSData *passwordData = [password dataUsingEncoding:NSUTF8StringEncoding];
    const char *passwordPointer = [passwordData bytes];
    int passwordLenght = [passwordData length];
    
    int result = cryptutil_decrypt(helper_, dataPointer, dataLength,
                                   passwordPointer, passwordLenght);
    
    NSString *resultString = nil;
    if (result == 0) {
        const char *resultPointer = crypthelper_getptr(helper_);
        int resultLength = crypthelper_getlen(helper_);
        resultString = [[[NSString alloc]
                         initWithBytes:resultPointer 
                         length:resultLength 
                         encoding:NSUTF8StringEncoding] autorelease];
    }
    return resultString;
}

@end
